diff -ruN vdr-1.7.38/CONTRIBUTORS vdr-1.7.39/CONTRIBUTORS
--- vdr-1.7.38/CONTRIBUTORS	2013-02-17 13:12:41.000000000 +0100
+++ vdr-1.7.39/CONTRIBUTORS	2013-03-03 14:01:26.000000000 +0100
@@ -694,6 +694,8 @@
  for reporting a crash in a plugin using cDeviceHook when VDR ends
  for reporting that "include" needs to be removed from the DVBDIR setting in the VDR
  Makefile
+ for helping to debug a problem with reduced number of retries in Transfer Mode on
+ SD-FF cards
 
 Reinhard Walter Buchner <rw.buchner@freenet.de>
  for adding some satellites to 'sources.conf'
@@ -1009,6 +1011,7 @@
  but one of them ends in an additional digit, as in "abc" and "abc2"
  for reporting multiple occurrences of the same directory in the recordings list ini
  case there are directories that only differ in non-alphanumeric characters
+ for reporting a problem with reduced number of retries in Transfer Mode on SD-FF cards
 
 Olivier Jacques <jacquesolivier@hotmail.com>)
  for translating OSD texts to the French language
@@ -1777,6 +1780,8 @@
  for suggesting to shift editing marks that don't point to an I-frame towards the next I-frame
  when a recording is played
  for requesting to keep using relative paths when building plugins locally
+ for fixing a problem with detecting user inactivity in case the system time is
+ changed after VDR has been started
 
 Sven Kreiensen <svenk@kammer.uni-hannover.de>
  for his help in keeping 'channels.conf.terr' up to date
@@ -2001,6 +2006,7 @@
  for adding '-p' to the cp command in the install-conf target of the Makefile
  for reporting that some special characters are dropped by Doxygen and thus need to
  be escaped
+ for changing the template for PLGCFG to $(CONFDIR)/plugins.mk
 
 Steffen Beyer <cpunk@reactor.de>
  for fixing setting the colored button help after deleting a recording in case the next
@@ -2362,7 +2368,7 @@
  for reporting a bug in deleting recordings that have been removed externally when
  running out of disk space
 
-Oleg Roitburd <oleg@roitburd.de>
+Oleg Roitburd <oroitburd@gmail.com>
  for translating OSD texts to the Russian language
  for updating 'sources.conf'
 
@@ -2374,6 +2380,7 @@
 
 Richard Lithvall <richard@lithvall.se>
  for adding a tolerance for symbol rate values that are off by one
+ for translating OSD texts to the Swedish language
 
 Tobias Grimm <tobias.grimm@e-tobi.net>
  for suggesting to use geteuid() to check whether VDR is running as user 'root'
@@ -2394,6 +2401,7 @@
  for suggesting to move setting LC_NUMERIC further up to make sure any floating point
  numbers use a decimal point
  for adding dependency on 'i18n' to 'install-i18n' in the VDR Makefile
+ for adding a manual page for 'svdrpsend'
 
 Helge Lenz <h.lenz@gmx.de>
  for reporting a bug in setting the 'Delta' parameter when calling the shutdown
@@ -2891,6 +2899,10 @@
  for reporting a problem with EPG scan on systems with only a single DVB device that
  use software output
  for fixing calling iconv_close() only with a valid iconv_t value
+ for reporting a problem with device bondings for devices that don't provide DVB-S
+ in case, for instance, there is now a DVB-T device where there used to be a bonded
+ DVB-S device
+ for fixing a possible deadlock in handling the tuners of bonded devices
 
 Sergiu Dotenco <sergiu.dotenco@googlemail.com>
  for reporting a missing initialization in sDvbSpuRect
@@ -3039,6 +3051,8 @@
  handling of PCR values
  for improving cutting MPEG-2 video
  for pointing out that FindHeader() can also be used in cMpeg2Fixer::AdjTref()
+ for reporting a problem with detecting user inactivity in case the system time is
+ changed after VDR has been started
 
 Peter Münster <pmlists@free.fr>
  for fixing 'make install' to not overwrite existing configuration files
@@ -3082,3 +3096,6 @@
 Matthias Senzel <matthias.senzel@t-online.de>
  for reporting a problem with switching back to live viewing after replay in a setup
  with device bonding
+
+Marek Nazarko <mnazarko@gmail.com>
+ for translating OSD texts to the Polish language
diff -ruN vdr-1.7.38/HISTORY vdr-1.7.39/HISTORY
--- vdr-1.7.38/HISTORY	2013-02-17 15:41:29.000000000 +0100
+++ vdr-1.7.39/HISTORY	2013-03-03 14:00:53.000000000 +0100
@@ -7590,7 +7590,7 @@
 - Updated the Ukrainian OSD texts (thanks to Yarema Aka Knedlyk).
 - Updated the Estonian OSD texts (thanks to Arthur Konovalov).
 - Updated the Romanian OSD texts (thanks to Lucian Muresan).
-- Updated the French OSD texts (thanks to Marc Perrudin, Bernard Jaulini and Peter
+- Updated the French OSD texts (thanks to Marc Perrudin, Bernard Jaulin and Peter
   Münster).
 - Updated the Macedonian OSD texts (thanks to Dimitar Petrovski).
 - Fixed moving editing marks, so that they don't get overwritten with old values
@@ -7644,3 +7644,43 @@
 - Removed trailing whitespace.
 - Expanded tabs in PLUGINS/src/dvbhddevice/setup.c.
 - Some formatting fixes.
+
+2013-03-03: Version 1.7.39
+
+- Updated the Finnish OSD texts (thanks to Rolf Ahrenberg).
+- Updated the Polish OSD texts (thanks to Marek Nazarko).
+- Modified handling user inactivity in the shutdown handler to avoid a problem in case
+  the system time is changed after VDR has been started (thanks to Udo Richter, reported
+  by Sören Moch).
+- Updated the Czech OSD texts (thanks to Ales Jurik).
+- Changed the template for PLGCFG to $(CONFDIR)/plugins.mk (thanks to Ville Skyttä).
+- Updated the Swedish OSD texts (thanks to Richard Lithvall).
+- Now clearing device bondings for devices that don't provide DVB-S in the Setup/LNB
+  menu (reported by Juergen Lock).
+- Fixed a possible deadlock in handling the tuners of bonded devices (thanks to
+  Juergen Lock).
+- Improved working around the broken driver values for SNR in case of a "TT-budget
+  S2-3200" receiving DVB-S2.
+- The demos in the "osddemo" plugin can now also be ended with the "Back" key.
+- Fixed flashing OSD in "high level OSD" mode of the TT S2-6400 in case a menu is open
+  while subtitles are being displayed.
+- Fixed stuttering or asynchronous audio after changing the audio track. This is done
+  by doing a "jump" to the current position, which clears all buffers. However, this
+  only works with TS recordings. With PES recordings it causes a segfault - haven't
+  been able to figure out why.
+- Added a manual page for 'svdrpsend' (thanks to Tobias Grimm).
+- Fixed immediately disappearing subtitle track menu in "high level OSD" mode of the
+  TT S2-6400 when selecting "No subtitles".
+- Updated the French OSD texts (thanks to Bernard Jaulin).
+- Updated the Dutch OSD texts (thanks to Carel Willemse).
+- Removed all "fuzzy" translations from the files ar.po, hu_HU.po and sr_SR.po, because
+  more often than not they are just wrong.
+- Now calling DeviceClear() in cTransfer::Receive() if the output device blocks, instead
+  of not retrying for 10 seconds (reported by Andreas Mair, with help from Oliver Endriss).
+- Updated the Spanish OSD texts (thanks to Luca Olivetti).
+- Updated the Hungarian language texts (thanks to István Füley).
+- Changed the calls to Skins.QueueMessage() in vdr.c that are related to reporting the
+  status of the editing process back to Skins.Message() in order to have them appear
+  immediately.
+- When sorting recordings by name, folders are now always at the top of the list.
+- Updated the Russian OSD texts (thanks to Oleg Roitburd).
diff -ruN vdr-1.7.38/INSTALL vdr-1.7.39/INSTALL
--- vdr-1.7.38/INSTALL	2013-02-08 09:48:49.000000000 +0100
+++ vdr-1.7.39/INSTALL	2013-02-19 10:48:54.000000000 +0100
@@ -424,6 +424,10 @@
 of these methods, it is necessary that your devices are always created in the
 same sequence when the drivers are loaded. You may need to configure some
 proper "udev" rules to make sure this happens.
+If you use "Device Bonding" and you add devices to your setup that don't
+provide DVB-S and take up a position in which there used to be a bonded DVB-S
+device, make sure you open, adjust (if necessary) and confirm the Setup/LNB
+menu to have the device bondings set correctly again.
 
 Running VDR with DVB-C (cable) or DVB-T (terrestrial):
 ------------------------------------------------------
diff -ruN vdr-1.7.38/Make.config.template vdr-1.7.39/Make.config.template
--- vdr-1.7.38/Make.config.template	2013-02-08 11:31:38.000000000 +0100
+++ vdr-1.7.39/Make.config.template	2013-02-18 11:55:39.000000000 +0100
@@ -6,7 +6,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Make.config.template 2.18 2013/02/08 10:31:38 kls Exp $
+# $Id: Make.config.template 2.19 2013/02/18 10:55:39 kls Exp $
 
 ### The C compiler and options:
 
@@ -62,7 +62,7 @@
 
 # Use this if you want to have a central place where you configure compile time
 # parameters for plugins:
-#PLGCFG = $(CONFDIR)/plugins.conf
+#PLGCFG = $(CONFDIR)/plugins.mk
 
 ### The remote control:
 
diff -ruN vdr-1.7.38/Makefile vdr-1.7.39/Makefile
--- vdr-1.7.38/Makefile	2013-02-17 12:08:04.000000000 +0100
+++ vdr-1.7.39/Makefile	2013-02-24 11:40:23.000000000 +0100
@@ -4,7 +4,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Makefile 2.52 2013/02/17 11:08:04 kls Exp $
+# $Id: Makefile 2.53 2013/02/24 10:40:23 kls Exp $
 
 .DELETE_ON_ERROR:
 
@@ -273,6 +273,7 @@
 	@mkdir -p $(DESTDIR)$(MANDIR)/man5
 	@gzip -c vdr.1 > $(DESTDIR)$(MANDIR)/man1/vdr.1.gz
 	@gzip -c vdr.5 > $(DESTDIR)$(MANDIR)/man5/vdr.5.gz
+	@gzip -c svdrpsend.1 > $(DESTDIR)$(MANDIR)/man1/svdrpsend.1.gz
 
 # Plugins:
 
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/HISTORY vdr-1.7.39/PLUGINS/src/dvbhddevice/HISTORY
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/HISTORY	2013-02-16 11:36:47.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/HISTORY	2013-02-24 13:00:41.000000000 +0100
@@ -59,3 +59,11 @@
 2013-02-16: Version 0.0.8
 
 - Added missing $(LDFLAGS) to the Makefile (thanks to Ville Skyttä).
+
+2013-02-24: Version 0.0.9
+
+- Updated the Finnish OSD texts (thanks to Rolf Ahrenberg).
+- Updated the Italian OSD texts (thanks to Diego Pierotto).
+- Fixed flashing OSD in "high level OSD" mode in case a menu is open while subtitles
+  are being displayed.
+- Fixed immediately disappearing subtitle track menu when selecting "No subtitles".
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/Makefile vdr-1.7.39/PLUGINS/src/dvbhddevice/Makefile
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/Makefile	2013-02-16 11:34:53.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/Makefile	2013-03-02 18:58:21.000000000 +0100
@@ -1,7 +1,6 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 1.23 2013/02/16 10:34:53 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/dvbhddevice.c vdr-1.7.39/PLUGINS/src/dvbhddevice/dvbhddevice.c
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/dvbhddevice.c	2013-02-16 11:35:42.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/dvbhddevice.c	2013-03-03 12:22:39.000000000 +0100
@@ -2,8 +2,6 @@
  * dvbhddevice.c: A plugin for the Video Disk Recorder
  *
  * See the README file for copyright information and how to reach the author.
- *
- * $Id: dvbhddevice.c 1.22 2013/02/16 10:35:42 kls Exp $
  */
 
 #include <vdr/plugin.h>
@@ -12,7 +10,7 @@
 #include "menu.h"
 #include "setup.h"
 
-static const char *VERSION        = "0.0.8";
+static const char *VERSION        = "0.0.9";
 static const char *DESCRIPTION    = trNOOP("HD Full Featured DVB device");
 static const char *MAINMENUENTRY  = "dvbhddevice";
 
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/dvbhdffdevice.c vdr-1.7.39/PLUGINS/src/dvbhddevice/dvbhdffdevice.c
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/dvbhdffdevice.c	2013-02-17 15:10:06.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/dvbhdffdevice.c	2013-03-02 18:58:21.000000000 +0100
@@ -2,8 +2,6 @@
  * dvbhdffdevice.c: The DVB HD Full Featured device interface
  *
  * See the README file for copyright information and how to reach the author.
- *
- * $Id: dvbhdffdevice.c 1.49 2013/02/17 14:10:06 kls Exp $
  */
 
 #include <stdint.h>
@@ -498,6 +496,7 @@
         mHdffCmdIf->CmdAvSetDecoderInput(0, 0);
         mHdffCmdIf->CmdAvEnableSync(0, true);
         mHdffCmdIf->CmdAvSetPlayMode(0, true);
+        mHdffCmdIf->CmdAvMuteAudio(0, false);
     }
     else {
         if (playMode == pmNone)
@@ -562,6 +561,30 @@
     return -1;
 }
 
+cRect cDvbHdFfDevice::CanScaleVideo(const cRect &Rect, int Alignment)
+{
+    return Rect;
+}
+
+void cDvbHdFfDevice::ScaleVideo(const cRect &Rect)
+{
+    if (Rect == cRect::Null)
+    {
+        mHdffCmdIf->CmdAvSetVideoWindow(0, false, 0, 0, 0, 0);
+    }
+    else
+    {
+        int osdWidth;
+        int osdHeight;
+        double osdPixelAspect;
+
+        GetOsdSize(osdWidth, osdHeight, osdPixelAspect);
+        mHdffCmdIf->CmdAvSetVideoWindow(0, true,
+            Rect.X() * 1000 / osdWidth, Rect.Y() * 1000 / osdHeight,
+            Rect.Width() * 1000 / osdWidth, Rect.Height() * 1000 / osdHeight);
+    }
+}
+
 void cDvbHdFfDevice::TrickSpeed(int Speed)
 {
   freezed = false;
@@ -591,6 +614,7 @@
         mHdffCmdIf->CmdAvEnableSync(0, true);
     mHdffCmdIf->CmdAvSetVideoSpeed(0, 100);
     mHdffCmdIf->CmdAvSetAudioSpeed(0, 100);
+    mHdffCmdIf->CmdAvMuteAudio(0, false);
     cDevice::Play();
 }
 
@@ -604,8 +628,8 @@
 
 void cDvbHdFfDevice::Mute(void)
 {
-  //TODO???
-  cDevice::Mute();
+    mHdffCmdIf->CmdAvMuteAudio(0, true);
+    cDevice::Mute();
 }
 
 static HdffVideoStreamType_t MapVideoStreamTypes(int Vtype)
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/dvbhdffdevice.h vdr-1.7.39/PLUGINS/src/dvbhddevice/dvbhdffdevice.h
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/dvbhdffdevice.h	2012-12-03 14:43:55.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/dvbhdffdevice.h	2013-03-02 18:58:21.000000000 +0100
@@ -2,8 +2,6 @@
  * dvbhdffdevice.h: The DVB HD Full Featured device interface
  *
  * See the README file for copyright information and how to reach the author.
- *
- * $Id: dvbhdffdevice.h 1.9 2012/12/03 13:43:55 kls Exp $
  */
 
 #ifndef __DVBHDFFDEVICE_H
@@ -99,6 +97,8 @@
   virtual int PlayTsAudio(const uchar *Data, int Length);
 public:
   virtual int64_t GetSTC(void);
+  virtual cRect CanScaleVideo(const cRect &Rect, int Alignment = taCenter);
+  virtual void ScaleVideo(const cRect &Rect = cRect::Null);
   virtual void TrickSpeed(int Speed);
   virtual void Clear(void);
   virtual void Play(void);
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/hdffcmd.c vdr-1.7.39/PLUGINS/src/dvbhddevice/hdffcmd.c
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/hdffcmd.c	2012-11-15 10:19:47.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/hdffcmd.c	2013-03-02 18:58:21.000000000 +0100
@@ -2,8 +2,6 @@
  * hdffcmd.c: TODO(short description)
  *
  * See the README file for copyright information and how to reach the author.
- *
- * $Id: hdffcmd.c 1.26 2012/11/15 09:19:47 kls Exp $
  */
 
 #include <stdint.h>
@@ -175,6 +173,10 @@
     HdffCmdAvSetSyncShift(mOsdDev, SyncShift);
 }
 
+void cHdffCmdIf::CmdAvMuteAudio(uint8_t DecoderIndex, bool Mute)
+{
+    HdffCmdAvMuteAudio(mOsdDev, DecoderIndex, Mute);
+}
 
 void cHdffCmdIf::CmdOsdConfigure(const HdffOsdConfig_t * pConfig)
 {
@@ -309,6 +311,13 @@
     HdffCmdOsdDrawEllipse(mOsdDev, hDisplay, CX, CY, RadiusX, RadiusY, Color, Flags);
 }
 
+void cHdffCmdIf::CmdOsdDrawSlope(uint32_t hDisplay, int X, int Y, int Width, int Height,
+                                 uint32_t Color, uint32_t Type)
+{
+    //printf("Slope (%d,%d) %d x %d, %08X, %X\n", X, Y, Width, Height, Color, Type);
+    HdffCmdOsdDrawSlope(mOsdDev, hDisplay, X, Y, Width, Height, Color, Type);
+}
+
 void cHdffCmdIf::CmdOsdDrawText(uint32_t hDisplay, uint32_t hFont, int X, int Y, const char * pText, uint32_t Color)
 {
     //printf("Text %08X (%d,%d), %s, %08X\n", hFont, X, Y, pText, Color);
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/hdffcmd.h vdr-1.7.39/PLUGINS/src/dvbhddevice/hdffcmd.h
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/hdffcmd.h	2012-11-15 10:20:05.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/hdffcmd.h	2013-03-02 18:58:21.000000000 +0100
@@ -2,8 +2,6 @@
  * hdffcmd.h: TODO(short description)
  *
  * See the README file for copyright information and how to reach the author.
- *
- * $Id: hdffcmd.h 1.21 2012/11/15 09:20:05 kls Exp $
  */
 
 #ifndef _HDFF_CMD_H_
@@ -48,6 +46,7 @@
     void CmdAvSetAudioDownmix(HdffAudioDownmixMode_t DownmixMode);
     void CmdAvSetAudioChannel(uint8_t AudioChannel);
     void CmdAvSetSyncShift(int16_t SyncShift);
+    void CmdAvMuteAudio(uint8_t DecoderIndex, bool Mute);
 
     void CmdOsdConfigure(const HdffOsdConfig_t * pConfig);
     void CmdOsdReset(void);
@@ -74,6 +73,7 @@
     void CmdOsdDrawRectangle(uint32_t hDisplay, int X, int Y, int Width, int Height, uint32_t Color);
     void CmdOsdDrawEllipse(uint32_t hDisplay, int CX, int CY, int RadiusX, int RadiusY,
                            uint32_t Color, uint32_t Flags);
+    void CmdOsdDrawSlope(uint32_t hDisplay, int X, int Y, int Width, int Height, uint32_t Color, uint32_t Type);
     void CmdOsdDrawText(uint32_t hDisplay, uint32_t hFont, int X, int Y, const char * pText, uint32_t Color);
     void CmdOsdDrawUtf8Text(uint32_t hDisplay, uint32_t hFont, int X, int Y, const char * pText, uint32_t Color);
     void CmdOsdDrawTextW(uint32_t hDisplay, uint32_t hFont, int X, int Y, const uint16_t * pText, uint32_t Color);
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/hdffosd.c vdr-1.7.39/PLUGINS/src/dvbhddevice/hdffosd.c
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/hdffosd.c	2013-01-29 09:59:36.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/hdffosd.c	2013-03-02 18:58:21.000000000 +0100
@@ -2,8 +2,6 @@
  * hdffosd.c: Implementation of the DVB HD Full Featured On Screen Display
  *
  * See the README file for copyright information and how to reach the author.
- *
- * $Id: hdffosd.c 1.20 2013/01/29 08:59:36 kls Exp $
  */
 
 #include "hdffosd.h"
@@ -107,6 +105,10 @@
 cHdffOsd::~cHdffOsd()
 {
     //printf("~cHdffOsd %d %d\n", mLeft, mTop);
+    if (Active()) {
+        mHdffCmdIf->CmdOsdDrawRectangle(mDisplay, 0, 0, mDispWidth, mDispHeight, 0);
+        mHdffCmdIf->CmdOsdRenderDisplay(mDisplay);
+    }
     SetActive(false);
 
     for (int i = 0; i < MAX_NUM_FONTS; i++)
@@ -124,8 +126,6 @@
 
     if (mBitmapPalette != HDFF_INVALID_HANDLE)
         mHdffCmdIf->CmdOsdDeletePalette(mBitmapPalette);
-    mHdffCmdIf->CmdOsdDrawRectangle(mDisplay, 0, 0, mDispWidth, mDispHeight, 0);
-    mHdffCmdIf->CmdOsdRenderDisplay(mDisplay);
     mHdffCmdIf->CmdOsdDeleteDisplay(mDisplay);
 }
 
@@ -152,7 +152,7 @@
     {
         //printf("SetAreas %d: %d %d %d %d %d\n", i, Areas[i].x1, Areas[i].y1, Areas[i].x2, Areas[i].y2, Areas[i].bpp);
     }
-    if (mDisplay != HDFF_INVALID_HANDLE)
+    if (Active() && mDisplay != HDFF_INVALID_HANDLE)
     {
         mHdffCmdIf->CmdOsdDrawRectangle(mDisplay, 0, 0, mDispWidth, mDispHeight, 0);
         mHdffCmdIf->CmdOsdRenderDisplay(mDisplay);
@@ -251,7 +251,6 @@
 {
     int w = Font->Width(s);
     int h = Font->Height();
-    int limit = 0;
     int cw = Width ? Width : w;
     int ch = Height ? Height : h;
     int i;
@@ -345,7 +344,6 @@
 
     if (Width || Height)
     {
-        limit = x + cw;// - mLeft;
         if (Width)
         {
             if ((Alignment & taLeft) != 0)
@@ -510,6 +508,8 @@
 void cHdffOsd::DrawSlope(int x1, int y1, int x2, int y2, tColor Color, int Type)
 {
     //printf("DrawSlope\n");
+    mHdffCmdIf->CmdOsdDrawSlope(mDisplay, mLeft + x1, mTop + y1,
+                                x2 - x1 + 1, y2 - y1 + 1, Color, Type);
     mChanged = true;
 }
 
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/hdffosd.h vdr-1.7.39/PLUGINS/src/dvbhddevice/hdffosd.h
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/hdffosd.h	2011-01-30 16:27:48.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/hdffosd.h	2013-03-02 18:58:21.000000000 +0100
@@ -2,8 +2,6 @@
  * hdffosd.h: Implementation of the DVB HD Full Featured On Screen Display
  *
  * See the README file for copyright information and how to reach the author.
- *
- * $Id: hdffosd.h 1.2 2011/01/30 15:27:48 kls Exp $
  */
 
 #ifndef _HDFF_OSD_H_
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.c vdr-1.7.39/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.c
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.c	2012-11-13 21:19:39.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.c	2013-03-02 18:58:21.000000000 +0100
@@ -468,3 +468,39 @@
     osd_cmd.cmd_len = HdffCmdSetLength(&cmdBuf);
     return ioctl(OsdDevice, OSD_RAW_CMD, &osd_cmd);
 }
+
+int HdffCmdAvMuteAudio(int OsdDevice, uint8_t DecoderIndex, int Mute)
+{
+    uint8_t cmdData[16];
+    BitBuffer_t cmdBuf;
+    osd_raw_cmd_t osd_cmd;
+
+    BitBuffer_Init(&cmdBuf, cmdData, sizeof(cmdData));
+    memset(&osd_cmd, 0, sizeof(osd_raw_cmd_t));
+    osd_cmd.cmd_data = cmdData;
+    HdffCmdBuildHeader(&cmdBuf, HDFF_MSG_TYPE_COMMAND,
+                       HDFF_MSG_GROUP_AV_DECODER,
+                       HDFF_MSG_AV_MUTE_AUDIO);
+    BitBuffer_SetBits(&cmdBuf, 4, DecoderIndex);
+    BitBuffer_SetBits(&cmdBuf, 1, Mute ? 1 : 0);
+    osd_cmd.cmd_len = HdffCmdSetLength(&cmdBuf);
+    return ioctl(OsdDevice, OSD_RAW_CMD, &osd_cmd);
+}
+
+int HdffCmdAvMuteVideo(int OsdDevice, uint8_t DecoderIndex, int Mute)
+{
+    uint8_t cmdData[16];
+    BitBuffer_t cmdBuf;
+    osd_raw_cmd_t osd_cmd;
+
+    BitBuffer_Init(&cmdBuf, cmdData, sizeof(cmdData));
+    memset(&osd_cmd, 0, sizeof(osd_raw_cmd_t));
+    osd_cmd.cmd_data = cmdData;
+    HdffCmdBuildHeader(&cmdBuf, HDFF_MSG_TYPE_COMMAND,
+                       HDFF_MSG_GROUP_AV_DECODER,
+                       HDFF_MSG_AV_MUTE_VIDEO);
+    BitBuffer_SetBits(&cmdBuf, 4, DecoderIndex);
+    BitBuffer_SetBits(&cmdBuf, 1, Mute ? 1 : 0);
+    osd_cmd.cmd_len = HdffCmdSetLength(&cmdBuf);
+    return ioctl(OsdDevice, OSD_RAW_CMD, &osd_cmd);
+}
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.h vdr-1.7.39/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.h
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.h	2012-11-13 21:19:39.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.h	2013-03-02 18:58:21.000000000 +0100
@@ -151,4 +151,9 @@
 
 int HdffCmdAvSetSyncShift(int OsdDevice, int16_t SyncShift);
 
+int HdffCmdAvMuteAudio(int OsdDevice, uint8_t DecoderIndex, int Mute);
+
+int HdffCmdAvMuteVideo(int OsdDevice, uint8_t DecoderIndex, int Mute);
+
+
 #endif /* HDFFCMD_AV_H */
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_defs.h vdr-1.7.39/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_defs.h
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_defs.h	2012-11-13 21:19:39.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_defs.h	2013-03-02 18:58:21.000000000 +0100
@@ -71,6 +71,8 @@
     HDFF_MSG_AV_SET_AUDIO_CHANNEL,
     HDFF_MSG_AV_SET_PLAY_MODE,
     HDFF_MSG_AV_SET_OPTIONS,
+    HDFF_MSG_AV_MUTE_AUDIO,
+    HDFF_MSG_AV_MUTE_VIDEO,
 
     HDFF_MSG_MUX_SET_VIDEO_OUT = 0,
     HDFF_MSG_MUX_SET_SLOW_BLANK,
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_osd.c vdr-1.7.39/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_osd.c
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_osd.c	2012-06-14 20:59:28.000000000 +0200
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_osd.c	2013-03-02 18:58:21.000000000 +0100
@@ -546,6 +546,30 @@
     return ioctl(OsdDevice, OSD_RAW_CMD, &osd_cmd);
 }
 
+int HdffCmdOsdDrawSlope(int OsdDevice, uint32_t Display, uint16_t X,
+                        uint16_t Y, uint16_t Width, uint16_t Height,
+                        uint32_t Color, uint32_t Type)
+{
+    uint8_t cmdData[28];
+    BitBuffer_t cmdBuf;
+    osd_raw_cmd_t osd_cmd;
+
+    BitBuffer_Init(&cmdBuf, cmdData, sizeof(cmdData));
+    memset(&osd_cmd, 0, sizeof(osd_raw_cmd_t));
+    osd_cmd.cmd_data = cmdData;
+    HdffCmdBuildHeader(&cmdBuf, HDFF_MSG_TYPE_COMMAND, HDFF_MSG_GROUP_OSD,
+                       HDFF_MSG_OSD_DRAW_SLOPE);
+    BitBuffer_SetBits(&cmdBuf, 32, Display);
+    BitBuffer_SetBits(&cmdBuf, 16, X);
+    BitBuffer_SetBits(&cmdBuf, 16, Y);
+    BitBuffer_SetBits(&cmdBuf, 16, Width);
+    BitBuffer_SetBits(&cmdBuf, 16, Height);
+    BitBuffer_SetBits(&cmdBuf, 32, Color);
+    BitBuffer_SetBits(&cmdBuf, 32, Type);
+    osd_cmd.cmd_len = HdffCmdSetLength(&cmdBuf);
+    return ioctl(OsdDevice, OSD_RAW_CMD, &osd_cmd);
+}
+
 int HdffCmdOsdDrawText(int OsdDevice, uint32_t Display, uint32_t Font,
                        uint16_t X, uint16_t Y, const char * Text,
                        uint32_t Color)
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_osd.h vdr-1.7.39/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_osd.h
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_osd.h	2012-06-14 20:59:28.000000000 +0200
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_osd.h	2013-03-02 18:58:21.000000000 +0100
@@ -145,6 +145,10 @@
                           uint16_t CY, uint16_t RadiusX, uint16_t RadiusY,
                           uint32_t Color, uint32_t Flags);
 
+int HdffCmdOsdDrawSlope(int OsdDevice, uint32_t Display, uint16_t X,
+                        uint16_t Y, uint16_t Width, uint16_t Height,
+                        uint32_t Color, uint32_t Type);
+
 int HdffCmdOsdDrawText(int OsdDevice, uint32_t Display, uint32_t Font,
                        uint16_t X, uint16_t Y, const char * Text,
                        uint32_t Color);
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/setup.c vdr-1.7.39/PLUGINS/src/dvbhddevice/setup.c
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/setup.c	2013-02-17 14:25:17.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/setup.c	2013-03-02 18:58:21.000000000 +0100
@@ -2,8 +2,6 @@
  * setup.c: Setup for the DVB HD Full Featured On Screen Display
  *
  * See the README file for copyright information and how to reach the author.
- *
- * $Id: setup.c 1.19 2013/02/17 13:25:17 kls Exp $
  */
 
 #include "setup.h"
@@ -436,26 +434,26 @@
 
 eOSState cHdffSetupPage::ProcessKey(eKeys key)
 {
-        eOSState state = cMenuSetupPage::ProcessKey(key);
+    eOSState state = cMenuSetupPage::ProcessKey(key);
 
-        if (state == osContinue)
+    if (state == osContinue)
+    {
+        cOsdItem * item;
+        switch (key)
         {
-                cOsdItem * item;
-                switch (key)
+            case kLeft:
+            case kRight:
+                item = Get(Current());
+                if (item == mTvFormatItem)
                 {
-                        case kLeft:
-                        case kRight:
-                                item = Get(Current());
-                                if (item == mTvFormatItem)
-                                {
-                                    mVideoConversion = 0;
-                                        BuildVideoConversionItem();
-                                        Display();
-                                }
-                                break;
-                        default:
-                                break;
+                    mVideoConversion = 0;
+                    BuildVideoConversionItem();
+                    Display();
                 }
+                break;
+            default:
+                break;
         }
-        return state;
+    }
+    return state;
 }
diff -ruN vdr-1.7.38/PLUGINS/src/dvbhddevice/setup.h vdr-1.7.39/PLUGINS/src/dvbhddevice/setup.h
--- vdr-1.7.38/PLUGINS/src/dvbhddevice/setup.h	2012-11-15 10:21:07.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/dvbhddevice/setup.h	2013-03-02 18:58:21.000000000 +0100
@@ -2,8 +2,6 @@
  * setup.h: Setup for the DVB HD Full Featured On Screen Display
  *
  * See the README file for copyright information and how to reach the author.
- *
- * $Id: setup.h 1.13 2012/11/15 09:21:07 kls Exp $
  */
 
 #ifndef _HDFF_SETUP_H_
diff -ruN vdr-1.7.38/PLUGINS/src/osddemo/HISTORY vdr-1.7.39/PLUGINS/src/osddemo/HISTORY
--- vdr-1.7.38/PLUGINS/src/osddemo/HISTORY	2013-02-13 14:53:38.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/osddemo/HISTORY	2013-02-19 13:44:08.000000000 +0100
@@ -51,3 +51,7 @@
 
 - Added demos of the DrawEllipse() and DrawSlope() function (press '1' or '2',
   respectively).
+
+2013-02-19: Version 0.3.1
+
+- The demos can now also be ended with the "Back" key.
diff -ruN vdr-1.7.38/PLUGINS/src/osddemo/osddemo.c vdr-1.7.39/PLUGINS/src/osddemo/osddemo.c
--- vdr-1.7.38/PLUGINS/src/osddemo/osddemo.c	2013-02-17 14:16:34.000000000 +0100
+++ vdr-1.7.39/PLUGINS/src/osddemo/osddemo.c	2013-02-19 13:43:19.000000000 +0100
@@ -3,13 +3,13 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: osddemo.c 2.10 2013/02/17 13:16:34 kls Exp $
+ * $Id: osddemo.c 2.11 2013/02/19 12:43:19 kls Exp $
  */
 
 #include <vdr/osd.h>
 #include <vdr/plugin.h>
 
-static const char *VERSION        = "0.3.0";
+static const char *VERSION        = "0.3.1";
 static const char *DESCRIPTION    = "Demo of arbitrary OSD setup";
 static const char *MAINMENUENTRY  = "Osd Demo";
 
@@ -157,6 +157,7 @@
                      return osContinue;
        case k2:      DrawSlopes(osd);
                      return osContinue;
+       case kBack:
        case kOk:     return osEnd;
        default: return state;
        }
@@ -533,6 +534,7 @@
                      SetArea();
                      DrawSlopes(osd);
                      break;
+       case kBack:
        case kOk:     return osEnd;
        default: return state;
        }
diff -ruN vdr-1.7.38/config.h vdr-1.7.39/config.h
--- vdr-1.7.38/config.h	2013-02-14 16:13:59.000000000 +0100
+++ vdr-1.7.39/config.h	2013-02-18 11:41:43.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.67 2013/02/14 15:13:59 kls Exp $
+ * $Id: config.h 2.69 2013/02/18 10:41:43 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.38"
-#define VDRVERSNUM   10738  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.39"
+#define VDRVERSNUM   10739  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.38"
-#define APIVERSNUM   10738  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.39"
+#define APIVERSNUM   10739  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
